'use strict';
import io from 'socket.io-client';

/*
  Messages :
    - disconnect
    - reconnecting
    - reconnect
    - reconnect_failed
    -
*/
const SERVER_URL = process.env.SERVER_URL || 'http://localhost';
const SERVER_PORT = process.env.SERVER_PORT || 4000;

export default class SocketService {
  constructor() {

    //this.ioClient = io.connect(SERVER_URL + ":" + SERVER_PORT + '/');
  }

  connect(serverUrl, serverPort) {
    this.disconnected=false;
    this.ioClient = io.connect(serverUrl + ":" + serverPort);

    console.log("is connected : " + this.ioClient.connected);
    this.ioClient.on('disconnect', () => {
      console.log("Connection with server lost");

    });
    this.ioClient.on('connect', () => {
      console.log("Connected to server");

    });
  }
  auth(name) {
    return new Promise(function (resolve, reject) {
      this.ioClient.emit('auth', name, function (response) {
        if (response.res === "ok") {
          resolve(response.message);
        } else {
          reject(response.message);
        }
      });
    });
  }
}
